package com.brackeen.javagamebook.util;

/**
    Monitoruje rozmiar sterty, rozmiar alokacji, zmiany w alokacji,
    zmiany w rozmiarze sterty i wykrywa zbieranie nieużytków (gdy
    zmniejsza się wielkość alokacji). Wywołaj takeSample() aby odczytać
    "próbkę" bieżącego stanu pamięci.
*/
public class MemMonitor {

    /**
        Klasa Data zawiera informacje na temat serii wartości 
        zmiennoprzecinkowych. Można pobrać minimalną, maksymalną,
        sumę i ilość danych.
    */
    public static class Data {

        float lastValue = 0;
        float min = Float.MAX_VALUE;
        float max = Float.MIN_VALUE;
        float sum = 0;
        int count = 0;

        public void addValue(float value) {
            lastValue = value;
            sum+=value;
            count++;
            min = Math.min(min, value);
            max = Math.max(max, value);
        }


        public String toString() {
            return "Min: " + toByteFormat(min) + "  " +
                   "Max: " + toByteFormat(max) + "  " +
                   "Śre: " + toByteFormat(sum / count);
        }
    }

    private Data heapSize = new Data();
    private Data allocSize = new Data();
    private Data allocIncPerUpdate = new Data();
    private int numHeapIncs = 0;
    private long startTime = System.currentTimeMillis();


    /**
        Odczytuje próbkę bieżącego stanu pamięci.
    */
    public void takeSample() {
        Runtime runtime = Runtime.getRuntime();
        long currHeapSize = runtime.totalMemory();
        long currAllocSize = currHeapSize - runtime.freeMemory();

        if (currHeapSize > heapSize.lastValue) {
            numHeapIncs++;
        }
        if (currAllocSize >= allocSize.lastValue) {
            allocIncPerUpdate.addValue(
                (currAllocSize - allocSize.lastValue));
        }

        heapSize.addValue(currHeapSize);
        allocSize.addValue(currAllocSize);
    }


    /**
        Konwertuje liczbę bajtów na reprezentację w postaci ciągu 
        reprezentującego bajty, kilobajty, megabajty ,itd.
    */
    public static String toByteFormat(float numBytes) {
        String[] labels = {" bajtów", " KB", " MB", " GB"};
        int labelIndex = 0;

        // wybór najbardziej odpowiedniej etykiety
        while (labelIndex < labels.length - 1 && numBytes > 1024) {
            numBytes/=1024;
            labelIndex++;
        }
        return (Math.round(numBytes*10)/10f) + labels[labelIndex];
    }


    public String toString() {
        long time = System.currentTimeMillis() - startTime;
        float timeSecs = (float)time / 1000;
        return "Całkowity czas: " + timeSecs + " s\n" +
            "Sterta: " + heapSize + "\n" +
            "Alokacje: " + allocSize + "\n" +
            "Powiększeń alokacji: " + allocIncPerUpdate + "\n" +
            "Ilość powiększeń sterty: " + numHeapIncs;
    }
}
